/***************************************************************************
 *   Copyright (C) 2005 by Rico Rommel   *
 *   ricorommel@web.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#include <stdio.h>
#include <stdlib.h>

#include "userdata.h"
//#include "pathtools.h"
#include "index.h"
#include "syncfiles.h"
#include "help.h"

#define VERSION		"0.1.0"

FILE *output;

int main(int argc, char *argv[])
{

	int usercount, filecount, dummy;
	_userdata *UserData = NULL;
	_userdata *MasterData = NULL;
	_fileindex *FileIndex;
 	output = stdout;
	int i,n;

	int delmode = 0;
	int syncmode = 1;
	int omode = 0;


	if (argc > 1) {
		for (i=0; i < argc; i++) {

			if (strcmp(argv[i], "--help") == 0) printhelp();

			if (strcmp(argv[i], "-v") == 0) {fprintf(output, "%s\n",VERSION); exit(0); }

			if (strcmp(argv[i], "-u") == 0)	UserData = CreateUserDataFromCommandline(argc, argv, i+1, &usercount);
	
			if (strcmp(argv[i], "-d") == 0) {delmode = 1; syncmode = 0;} 

			if (strcmp(argv[i], "-n") == 0) {MasterData = CreateUserDataFromCommandline(i+2, argv, i+1, &dummy); omode = 1;}

			if (strcmp(argv[i], "-q") == 0) {output = fopen("/dev/null", "w");} 

			if (strcmp(argv[i], "-o") == 0) {MasterData = CreateUserDataFromCommandline(i+2, argv, i+1, &dummy); omode = 1; delmode =1; }

			}
		}
	


	if (UserData != NULL) {
	
	
	if (syncmode == 1) {
	fprintf(output, "Erstelle Dateiindex...");
	if (omode == 1 ) {
		//Falls Master auch unter -u angegeben wurd, muss er aus Userdata entfernt werden
		for (i = 0; i < usercount; i++) 
			if (((UserData+i)->userid == (MasterData)->userid) && (strcmp((UserData+i)->dirname, MasterData->dirname) == 0)) {
				for (n = i; n < usercount; n++) {
					memcpy((UserData+n+1),(UserData+n), sizeof(_userdata));
					}
				usercount--;
				}

		FileIndex = CreateFileIndex(MasterData, 1, &filecount);
		}

	else FileIndex = CreateFileIndex(UserData, usercount, &filecount);

	fprintf(output, "fertig\n");	

	}

	if (delmode == 1) {
	DeleteAllFiles(UserData, usercount);
	}

	//Master wieder hinzu fügen
/*	if (omode == 1) {
		UserData = realloc(UserData, (usercount+1)*(sizeof(_userdata)));
		memcpy((UserData+usercount), MasterData, sizeof(_userdata));
		usercount++;
		}
*/
//for (i=0; i < usercount; i++) fprintf(output, "%d, %s, %d \n", (UserData+i)->userid, (UserData+i)->dirname, (UserData+i)->timediff);

//for (i=0; i < filecount; i++) fprintf(output, "%d, %s, %s %d\n", (FileIndex+i)->userid, (FileIndex+i)->relpath, (FileIndex+i)->abspath, (FileIndex+i)->modtime);

	if (syncmode == 1) {
	fprintf(output, "Beginne Abgleich\n");
	SyncAllFiles(UserData, usercount, FileIndex, filecount);
	}

	
	//Aufräumen
	for (i=0; i < usercount; i++) free((UserData+i)->dirname);
	if (syncmode == 1) for (i=0; i < filecount; i++) free((FileIndex+i)->relpath);
	free(FileIndex);
	//free(UserData);
//	free(MasterData);
	
	return EXIT_SUCCESS;
	}
	else {
	fprintf(output, "\nKeine Benutzer angegebeben\n\n"); 
	return EXIT_FAILURE;
	}
}
